﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pattern.AbstractFactory
{
    /// <summary>
    /// Concrete Factory for Oracle
    /// </summary>
    class OracleDbFactory
        : DbFactory
    {
        public override Connection Connection()
        {
            return new OracleConnection();
        }

        public override Command Command()
        {
            return new OracleCommand();
        }

        public override Transaction Transaction()
        {
            return new OracleTransaction();
        }
    }

    /// <summary>
    /// Concrete Factory for MySql
    /// </summary>
    class MySqlDbFactory
        : DbFactory
    {
        public override Connection Connection()
        {
            return new MySqlConnection();
        }

        public override Command Command()
        {
            return new MySqlCommand();
        }

        public override Transaction Transaction()
        {
            return new MySqlTransaction();
        }
    }
}
