﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pattern.ChainOfResponsibility
{
    // handler
    public abstract class BaseRequestHandler<TRequest>
        where TRequest : BaseRequest
    {
        public BaseRequestHandler<TRequest> Successor
        {
            protected get;
            set;
        }

        public void ExecuteRequest(TRequest request)
        {
            Execute(request);

            if (Successor != null)
                Successor.ExecuteRequest(request);
        }

        protected abstract void Execute(TRequest request);
    }
}
