﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pattern.ChainOfResponsibility
{

    /// <summary>
    /// http://thesoftwarearchitecture.wordpress.com/2013/08/20/chain-of-responsibility-design-pattern/
    /// </summary>
    class Program
    {
        static void Main(string[] args)
        {
            // sample 1
            // Setup Chain of Responsibility
            BaseHandler h1 = new ConcreteHandler1();
            BaseHandler h2 = new ConcreteHandler2();
            BaseHandler h3 = new ConcreteHandler3();
            
            h1.SetSuccessor(h2);
            h2.SetSuccessor(h3);

            h1.ExecuteRequest(10);
            h2.ExecuteRequest(21);
            

            // sample 2
            BaseRequestHandler<LoanRequest> handler = new FirstApproverRequestHandler();
            BaseRequestHandler<LoanRequest> handler1 = new SecondApproverRequestHandler();
            BaseRequestHandler<LoanRequest> handler2 = new ManagerApproverRequestHandler();

            // setup chain of responsibility
            handler.Successor = handler1;
            handler1.Successor = handler2;

            // request object
            LoanRequest request = new LoanRequest();
            request.State = State.ApprovedApproval;

            // handler -> request executer
            handler.ExecuteRequest(request);


            Console.ReadLine();
        }
    }
}
