﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pattern.Composite
{
    public class CompositionStaff
        : Staff
    {
        private List<Staff> leafs = new List<Staff>();

        public CompositionStaff(string title)
            : base(title)
        {
        }

        public override void ShowProfile()
        {
            Console.WriteLine("-{0}", this.Title);

            // Display each child element on this node
            foreach (Staff item in leafs)
            {
                item.ShowProfile();
            }
        }

        public override void Add(Staff staff)
        {
            leafs.Add(staff);
        }

        public override void Remove(Staff staff)
        {
            leafs.Remove(staff);
        }
    }
}
