﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Pattern.Facade
{
    public class SingletonFacade
    {
        public static SingletonFacade Obj = null;

        public static SingletonFacade GetObj()
        {
            if (Obj == null)
                Obj = new SingletonFacade();
            return Obj;
        }
        
        private SingletonFacade()
        {
            this.rSubSystemOne = new SubSystemOne();
            this.rSubSystemTwo = new SubSystemTwo();
            this.rSubSystemThree = new SubSystemThree();
        }

        // specific operation methods
        public void Do()
        {
            this.rSubSystemOne.Write();
            this.rSubSystemThree.Write();
        }

        private SubSystemTwo rSubSystemTwo;
        private SubSystemOne rSubSystemOne;
        private SubSystemThree rSubSystemThree;
    }
}
