﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pattern.Flyweight
{
    /// <summary>
    /// FlyWeight 
    /// </summary>
    abstract class Character
    {
        // içsel özellikler - instrinsic - state-independent
        protected char symbol;
        protected string font;
        protected string color;

        // dış özellikler - extrinsic - state-dependent
        protected short X;
        protected short Y;

        /// <summary>
        /// istemcinin bu özellikleri set edebilmesi için ctor kullanılmıştır.
        /// Eğer sabit değerler kullanılmak istenirsr bu tanımlama kaldırılabilir 
        /// ve doğrudan Concrete FlyWeight içierisinde değer atanır.
        /// </summary>
        public Character(char symbol, string font, string color)
        {
            this.symbol = symbol;
            this.color = color;
            this.font = font;
        }

        public Character()
        {
        }
        /// <summary>
        /// İstemcinin değiştirebileceği özellikler için
        /// gerekli operasyon methodu
        /// </summary>
        public abstract void MoveTo(short X, short Y);
    }
}
