﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pattern.Flyweight
{
    class CharacterFactory
    {
        Dictionary<char, Character> charactersPool;

        public CharacterFactory()
        {
            charactersPool = new Dictionary<char, Character>();
        }

        public Character GetCharacter(char symbol)
        {
            Character ch = null;

            if (charactersPool.ContainsKey(symbol))
                ch = charactersPool[symbol];
            else
            {
                switch (symbol)
                {
                    case 'A': ch = new A();
                        break;
                    case 'B': ch = new B();
                        break;
                    case 'C': ch = new C();
                        break;
                    default:
                        throw new Exception();
                }
                charactersPool.Add(symbol, ch);
            }
            return charactersPool[symbol];
        }
    }
}
