﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pattern.Interpreter
{
    public class AsciiParser
    : BaseParser
    {
        private List<BaseExpression> tokenList = new List<BaseExpression>();

        public AsciiParser(Context ctxt)
        {
            this.Context = ctxt;
        }

        public Context Context;
        
        public override void Parser()
        {
            foreach (Char ch in Context.Value.ToCharArray())
                tokenList.Add(new CharExpression(ch));

            // Interpret
            foreach (IExpression exp in tokenList)
                exp.Interpret(Context);
        }

    }
}
