﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pattern.NullObject
{
    public abstract class StaffBase
    {
        public abstract string IdentityNumber { get; set; }
        public abstract string FullName { get; set; }
        public abstract string Department { get; set; }

        public abstract int EfficiencyScore();
        public abstract Dictionary<int, string> TaskStatus();

        #region Null Implementation

        private static readonly NullStaff nullStaff = new NullStaff();

        public static NullStaff Null
        {
            get { return nullStaff; }
        }

        public class NullStaff
            : StaffBase
        {
            public override string IdentityNumber
            {
                get { return String.Empty; }
                set { }
            }

            public override string FullName
            {
                get { return String.Empty; }
                set { }
            }

            public override string Department
            {
                get { return String.Empty; }
                set { }
            }

            public override int EfficiencyScore()
            {
                // No operation or behaviour
                // But you can put operations depending on your case
                return 0;
            }

            public override Dictionary<int, string> TaskStatus()
            {
                // No operation or behaviour
                // But you can put operations depending on your case
                return null;
            }
        }

        #endregion
    }
}
