﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pattern.ObjectPool
{
    public class CloudPool
        : IPool<Cloud>
    {
        private static CloudPool _instance;
        private Queue pool = null;
        private int size = 10;

        private CloudPool()
        {
            pool = new Queue(this.size);
        }

        public static CloudPool getObj()
        {
            if (_instance == null)
                _instance = new CloudPool();

            return _instance;
        }

        /// <summary>
        /// Havuzda kuyrukta bekleyen nesneyi döner GET
        /// </summary>
        /// <returns></returns>
        public Cloud acquire()
        {
            if (pool.Count == 0)
                throw new ArgumentNullException();

            return (Cloud)pool.Dequeue();
        }

        /// <summary>
        /// havuza nesneyi eklemek için kullanılır 
        /// </summary>
        /// <param name="obj"></param>
        public void release(Cloud obj)
        {
            if (pool.Count > size)
                throw new ArgumentOutOfRangeException();

            pool.Enqueue(obj);
        }

        public void capacity(int size)
        {
            this.size = size;
        }

        public int count()
        {
            return pool.Count;
        }

        public ICollection objectsInPool()
        {
            return pool;
        }
    }
}
