﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pattern.ObjectPool
{
    class EmployeePool
    {
        static int _maxDefine = 3;

        static readonly Queue objPool = new Queue(_maxDefine);

        public Employee GetEmployee()
        {
            Employee objEmployee;
            if (Employee._intCounter >= 3 && objPool.Count > 1)
            {
                objEmployee = GetEmployeeFromPool();
            }
            else
            {
                objEmployee = CreateNewEmployee();
            }
            return objEmployee;
        }

        private Employee CreateNewEmployee()
        {
            Employee objEmp = new Employee();
            objPool.Enqueue(objEmp);
            return objEmp;
        }

        private Employee GetEmployeeFromPool()
        {
            Employee objEmp;
            if (objPool.Count > 1)
            {
                objEmp = (Employee)objPool.Dequeue();
                Employee._intCounter--;
            }
            else
            {
                objEmp = new Employee();
            }
            return objEmp;
        }
    }
}
