﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pattern.ObjectPool
{
    /// <summary>
    /// http://blog.yemrekeskin.com/post/2012/10/24/Object-Pool-Design-Pattern.aspx
    /// </summary>
    class Program
    {
        static void Main(string[] args)
        {
            Cloud c0 = new Cloud { ID = System.Guid.NewGuid().ToString(), Name = "YUNUS" };
            Cloud c1 = new Cloud { ID = System.Guid.NewGuid().ToString(), Name = "EMRE" };

            CloudPool d = CloudPool.getObj();
            d.release(c0);
            d.release(c1);

            Console.WriteLine("-----------BEFORE-----------------------");
            foreach (Cloud item in d.objectsInPool())
            {
                Console.WriteLine(item.Name);
            }
            Console.WriteLine("--------------------------------------");

            Console.WriteLine(d.count().ToString());

            Cloud r = d.acquire();
            Console.WriteLine(r.Name);

            r.Name = "KUBRA";

            Console.WriteLine(d.count().ToString());

            d.release(r);

            Console.WriteLine("-----------AFTER-----------------------");
            foreach (Cloud item in d.objectsInPool())
            {
                Console.WriteLine(item.Name);
            }
            Console.WriteLine("-------------------------------------");

            Console.ReadLine();
        }
    }
}
