﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pattern.Observer
{
    public class ObservableImpl<TObject>
         : IObservable<TObject>
    {
        protected readonly List<IObserver<TObject>> _list = null;
        public ObservableImpl()
        {
            _list = new List<IObserver<TObject>>();
        }

        public void Register(IObserver<TObject> observer)
        {
            if (!_list.Contains(observer))
                _list.Add(observer);
        }

        public void UnRegister(IObserver<TObject> observer)
        {
            if (_list.Contains(observer))
                _list.Remove(observer);
        }

        public void Notify(TObject obj)
        {
            foreach (IObserver<TObject> item in _list)
                item.Notify(obj);
        }
    }
}
