﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Pattern.Prototype
{
    /// <summary>
    /// Concrete Prototype
    /// </summary>
    public class Rectangle
        : FormPrototype
    {
        private Guid id;
        // default or initializer properties
        public int width { get; private set; }
        public int height { get; private set; }

        // detail properties
        public string Color { get; set; }
        public bool IsActive { get; set; }

        public Rectangle(int width, int height)
        {
            this.id = Guid.NewGuid();
            this.width = width;
            this.height = height;
        }

        public override FormPrototype Clone()
        {
            return this.MemberwiseClone() as FormPrototype;
        }

    }
}
