﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Pattern.UnitOfWork
{
    public class ContextFactory
        : IContextFactory, IDisposable
    {
        private SampleContext _sampleContext;

        public SampleContext GetContext()
        {
            return _sampleContext ?? (_sampleContext = new SampleContext());
        }

        public void Dispose()
        {
            if (null != _sampleContext)
                _sampleContext.Dispose();
        }
    }
}
