﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;

namespace Pattern.UnitOfWork
{
    // Repository Pattern
    public interface IRepository<TObject>
    {
        IQueryable<TObject> All();
        IQueryable<TObject> Filter(Expression<Func<TObject, bool>> predicate);
        IQueryable<TObject> Filter<Key>(Expression<Func<TObject, bool>> filter,
            out int total, int index = 0, int size = 50);
        bool Contains(Expression<Func<TObject, bool>> predicate);
        TObject Find(params object[] keys);
        TObject Find(Expression<Func<TObject, bool>> predicate);
        TObject Create(TObject t);
        int Delete(TObject t);
        int Delete(Expression<Func<TObject, bool>> predicate);
        int Update(TObject t);
 
        int Count { get; }
    }
}
